
import java.util.*;

public class PriorityQueue {

	private Entry[] entries;

	public PriorityQueue(){
		entries = new Entry[0];
	}

	public void enqueue(Comparable z,double priority){
		Entry[] tmp = new Entry[entries.length+1];
		for(int i=0;i<entries.length;i++){
			tmp[i] = entries[i];
		}
		tmp[tmp.length-1] = new Entry(z,priority);
		Arrays.sort(tmp);
		entries = tmp;
	}

	public double getHighestPriority(){
		if(entries.length>0){
			return entries[0].priority;
		}else{
			return -1;
		}
	}

	public Comparable dequeue(){
		if(entries.length>0){
			Comparable result = entries[0].object;
			Entry[] tmp = new Entry[entries.length-1];
			for(int i=1;i<entries.length;i++){
				tmp[i-1] = entries[i];
			}
			entries = tmp;
			return result;
		}else{
			return null;
		}
	}

	public String toString(){
		String result = "";
		for(int i=0;i<entries.length;i++){
			result += entries[i].object.toString() + "-" + entries[i].priority;
			if(i+1<entries.length){
				result += ",";
			}
		}
		return result;
	}

	private class Entry implements Comparable {

		private Comparable object;
		private double priority;

		public Entry(Comparable z,double p){
			object = z;
			priority = p;
		}

		public int compareTo(Object z){
			Entry e = (Entry)z;
			if(priority < e.priority){
				return -1;
			}else if(priority > e.priority){
				return 1;
			}else{
				return object.compareTo(e.object);
			}
		}

	}

}